summaryrefslogtreecommitdiffstats
path: root/tests/ts/kill
diff options
context:
space:
mode:
authorSami Kerola2014-04-12 01:33:55 +0200
committerSami Kerola2014-04-26 20:04:57 +0200
commit2d8aa0b7045b78133d0b86676b4107d6da123609 (patch)
treedba5724cb682266a7115ff99268dd7af3c92a23f /tests/ts/kill
parenttests: check various ways to specify kill signal (diff)
downloadkernel-qcow2-util-linux-2d8aa0b7045b78133d0b86676b4107d6da123609.tar.gz
kernel-qcow2-util-linux-2d8aa0b7045b78133d0b86676b4107d6da123609.tar.xz
kernel-qcow2-util-linux-2d8aa0b7045b78133d0b86676b4107d6da123609.zip
tests: check kill print pid option
CC: Bernhard Voelker <mail@bernhard-voelker.de> Signed-off-by: Sami Kerola <kerolasa@iki.fi>
Diffstat (limited to 'tests/ts/kill')
-rwxr-xr-xtests/ts/kill/print_pid69
1 files changed, 69 insertions, 0 deletions
diff --git a/tests/ts/kill/print_pid b/tests/ts/kill/print_pid
new file mode 100755
index 000000000..46bbb13aa
--- /dev/null
+++ b/tests/ts/kill/print_pid
@@ -0,0 +1,69 @@
+#!/bin/bash
+
+# This file is part of util-linux.
+#
+# This file is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This file is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+TS_TOPDIR="${0%/*}/../.."
+TS_DESC="print_pid"
+
+. "$TS_TOPDIR/functions.sh"
+ts_init "$*"
+
+ts_check_test_command "$TS_CMD_KILL"
+ts_check_test_command "$TS_HELPER_SIGRECEIVE"
+
+all_ok=true
+
+HELPER_SYMLINK="$TS_OUTDIR/$(mktemp -u XXXXXXXXXXXXXXX)"
+ln -s "$TS_HELPER_SIGRECEIVE" "$HELPER_SYMLINK"
+trap "rm -f $HELPER_SYMLINK" 0
+
+"$HELPER_SYMLINK" >> "$TS_OUTPUT" 2>&1 &
+TEST_PID=$!
+# test_sigreceive needs time to start up
+up=0
+for i in 0.01 0.1 1 1 1 1; do
+ awk 'BEGIN { retval=1 }
+ $1 ~ /^SigCgt/ {
+ lbyte = strtonum("0x" substr($2, 16, 16))
+ if (and(lbyte, 1)) {
+ retval=0
+ }
+ } END {
+ exit retval
+ }' /proc/$TEST_PID/status &&
+ up=1 &&
+ break
+ sleep $i
+done
+KILL_PID=$("$TS_CMD_KILL" -p ${HELPER_SYMLINK##*/} 2>> "$TS_OUTPUT" 2>&1)
+if [ $? -ne 0 ]; then
+ echo "kill -p did not work" >> "$TS_OUTPUT"
+ all_ok=false
+fi
+if [ "x$TEST_PID" != "x$KILL_PID" ]; then
+ echo "jobs -p $TEST_PID != kill -p $KILL_PID" >> "$TS_OUTPUT"
+ all_ok=false
+else
+ "$TS_CMD_KILL" -1 $TEST_PID
+ wait $TEST_PID
+ if [ $? -ne 1 ]; then
+ echo "wait $TEST_PID returned ${?}" >> "$TS_OUTPUT"
+ all_ok=false
+ fi
+fi
+
+if $all_ok; then
+ echo 'all ok' >> "$TS_OUTPUT"
+fi
+
+ts_finalize